%define	name	device-mapper
%define	version	1.02.24
%define	extraversion	%{nil}
%define	release	%mkrel 2

%ifarch %{ix86} x86_64 ppc ppc64 %{sunsparc} %mips %arm
%define	use_dietlibc	1
%else
%define	use_dietlibc	0
%endif

%define	build_dmeventd 1

%{?_with_dmeventd: %{expand: %%global build_dmeventd 1}}
%{?_without_dmeventd: %{expand: %%global build_dmeventd 0}}
%{?_with_dietlibc: %{expand: %%global use_dietlibc 1}}
%{?_without_dietlibc: %{expand: %%global use_dietlibc 0}}

%define	_sbindir	/sbin
%define	major	1.02

# Macro: %%{mklibname <name> [<major> [<minor>]] [-s] [-d]}
%define	libname		%mklibname devmapper %major
%define	develname	%mklibname devmapper -d
%define	event_libname	%mklibname devmapper-event %major
%define	event_develname	%mklibname devmapper-event -d

Summary:	Device mapper
Name:		%{name}
Version:	%{version}
Release:	%{release}
Source0:	ftp://sources.redhat.com/pub/dm/%{name}.%{version}%{extraversion}.tgz
Source1:	ftp://sources.redhat.com/pub/dm/%{name}.%{version}%{extraversion}.tgz.asc
Patch0:		device-mapper.1.02.24-build.patch
Patch1:		device-mapper.1.02.24-uint32_max.patch
Patch2:		device-mapper.1.02.22-pkgconfig.patch
Patch3:		device-mapper.1.02.22-canonicalize.patch
Patch4:		device-mapper.1.02.22-uint64.patch
License:	GPLv2 and LGPLv2
Group:		System/Kernel and hardware
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot
URL:		http://sources.redhat.com/dm/
BuildRequires:	autoconf
%if %{use_dietlibc}
BuildRequires:	dietlibc-devel
%else
BuildRequires:	glibc-static-devel
%endif

%description
The device-mapper driver enables the definition of new block
devices composed of ranges of sectors of existing devices.  This
can be used to define disk partitions - or logical volumes.

%package -n	dmsetup
Summary:	Device mapper setup tool
Group:		System/Kernel and hardware
Provides:	device-mapper = %{version}-%{release}
Provides:	dmeventd = %{version}-%{release}
Requires:	%{libname} = %{version}-%{release}

%description -n	dmsetup
Dmsetup manages logical devices that use the device-mapper driver.  
Devices are created by loading a table that specifies a target for
each sector (512 bytes) in the logical device.

%package -n	%{libname}
Summary:	Device mapper library
Group:		System/Kernel and hardware

%description -n	%{libname}
The device-mapper driver enables the definition of new block
devices composed of ranges of sectors of existing devices.  This
can be used to define disk partitions - or logical volumes.

This package contains the shared libraries required for running
programs which use device-mapper.

%package -n	%{develname}
Summary:	Device mapper development library
Group:		Development/C
Provides:	device-mapper-devel = %{version}-%{release}
Provides:	libdevmapper-devel = %{version}-%{release}
Requires:	%{libname} = %{version}-%{release}
Requires:	pkgconfig
Conflicts:	device-mapper-devel < %{version}-%{release}
Obsoletes:	%{mklibname devmapper 1.02 -d}

%description -n	%{develname}
The device-mapper driver enables the definition of new block
devices composed of ranges of sectors of existing devices.  This
can be used to define disk partitions - or logical volumes.

This package contains the header files and development libraries
for building programs which use device-mapper.

%if %{build_dmeventd}
%package -n	%{event_libname}
Summary:	Device mapper event library
Group:		System/Kernel and hardware

%description -n	%{event_libname}
The device-mapper-event library allows monitoring of active mapped devices.

This package contains the shared libraries required for running
programs which use device-mapper-event.

%package -n	%{event_develname}
Summary:	Device mapper event development library
Group:		Development/C
Provides:	device-mapper-event-devel = %{version}-%{release}
Provides:	libdevmapper-event-devel = %{version}-%{release}
Requires:	%{event_libname} = %{version}-%{release}
Requires:	%{develname} = %{version}-%{release}
Requires:	pkgconfig
Conflicts:	device-mapper-event-devel < %{version}-%{release}
Obsoletes:	%{mklibname devmapper-event 1.02 -d}

%description -n	%{event_develname}
The device-mapper-event library allows monitoring of active mapped devices.

This package contains the header files and development libraries
for building programs which use device-mapper-event.
%endif

%prep
%setup -q -n %{name}.%{version}%{extraversion}
%patch0 -p1 -b .build
%patch1 -p1 -b .uint32_max
%patch2 -p1 -b .pkgconfig
%patch3 -p1 -b .canonicalize
%patch4 -p1 -b .uint64
autoconf

%build
%if %{use_dietlibc}
# build fails with stack-protector enabled - AdamW 2007/08
export CFLAGS="%{optflags} -fno-stack-protector"
%endif
%configure2_5x --with-user=`id -un` --with-group=`id -gn` \
%if %{use_dietlibc}
	--enable-static_link_dietlibc \
%else
	--enable-static_link \
%endif
	--disable-selinux \
%if %{build_dmeventd}
	--enable-dmeventd \
%endif
	--enable-pkgconfig
%make

%install
rm -rf %{buildroot}
%makeinstall
mkdir -p %{buildroot}/%{_lib}
mv %{buildroot}%{_libdir}/libdevmapper.so.* $RPM_BUILD_ROOT/%{_lib}
ln -sf /%{_lib}/libdevmapper.so.%{major} %{buildroot}%{_libdir}/libdevmapper.so
%if %{use_dietlibc}
mv $RPM_BUILD_ROOT%{_sbindir}/dmsetup-static{-diet,}
%endif
chmod -R u+w %{buildroot} #else brp won't strip binaries

%clean
rm -rf %{buildroot}

%files -n dmsetup
%defattr(644,root,root,755)
%doc INSTALL INTRO README VERSION WHATS_NEW
#doc patches/*.patch.bz2
%doc scripts/*
%doc contrib/*
%attr(755,root,root) %{_sbindir}/dmsetup
%attr(755,root,root) %{_sbindir}/dmsetup-static
%attr(755,root,root) %{_sbindir}/dmeventd
%{_mandir}/man8/dmsetup.8*

%files -n %{libname}
%defattr(755,root,root)
/%{_lib}/libdevmapper.so.*

%if %mdkversion < 200900
%post -n %{libname} -p /sbin/ldconfig
%endif
%if %mdkversion < 200900
%postun -n %{libname} -p /sbin/ldconfig
%endif

%files -n %{develname}
%defattr(644,root,root,755)
%{_libdir}/libdevmapper.so
%{_libdir}/libdevmapper.a*
%{_includedir}/libdevmapper.h
%if %{use_dietlibc}
%{_libdir}/libdevmapper-diet.a*
%endif
%{_libdir}/pkgconfig/devmapper.pc

%if %{build_dmeventd}
%defattr(755,root,root)
%files -n %{event_libname}
%{_libdir}/libdevmapper-event.so.*

%post -n %{event_libname}
/sbin/ldconfig

%postun -n %{event_libname}
/sbin/ldconfig

%files -n %{event_develname}
%defattr(644,root,root,755)
%{_includedir}/libdevmapper-event.h
%{_libdir}/libdevmapper-event.so
%{_libdir}/libdevmapper-event.a*
%{_libdir}/pkgconfig/devmapper-event.pc
%endif



%changelog
* Tue Jan 19 2010 Texstar <texstar at gmail.com> 1.02.24-2pclos2010
- update for 2010 release

